'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _querystring = require('querystring');

var _querystring2 = _interopRequireDefault(_querystring);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _cheerio = require('cheerio');

var _cheerio2 = _interopRequireDefault(_cheerio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require("babel-polyfill");

var HttpClient = function () {
    function HttpClient() {
        _classCallCheck(this, HttpClient);

        this.client = _axios2.default.create({
            baseURL: "http://pretraga2.apr.gov.rs/ObjedinjenePretrage/Search"
        });
        this.token = '';
        this.cookie = '';
    }

    _createClass(HttpClient, [{
        key: 'grabToken',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var response, cookies, $, form;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return this.client.get('/Search');

                            case 2:
                                response = _context.sent;
                                cookies = [];

                                response.headers["set-cookie"].forEach(function (cookieData) {
                                    cookies.push(cookieData.substring(0, cookieData.indexOf(";")));
                                });
                                this.cookie = cookies.join("; ");
                                $ = _cheerio2.default.load(response.data);
                                form = $("form").serializeArray();

                                this.token = form.find(function (item) {
                                    return item.name === "__RequestVerificationToken";
                                }).value;

                                if (!(this.token === '')) {
                                    _context.next = 11;
                                    break;
                                }

                                throw new AssertionError("Token not found");

                            case 11:
                                return _context.abrupt('return', this.token);

                            case 12:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function grabToken() {
                return _ref.apply(this, arguments);
            }

            return grabToken;
        }()
    }, {
        key: 'tidyString',
        value: function tidyString(input) {
            return input.replace('\n', '').trim();
        }
    }, {
        key: 'searchByRegistrationNumber',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(regNo) {
                var response, $, row, td, data;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                if (!(this.token === '')) {
                                    _context2.next = 3;
                                    break;
                                }

                                _context2.next = 3;
                                return this.grabToken();

                            case 3:
                                _context2.prev = 3;
                                _context2.next = 6;
                                return this.client.request({
                                    url: '/SearchResult',
                                    method: 'post',
                                    data: _querystring2.default.stringify({
                                        "__RequestVerificationToken": this.token,
                                        "rdbtnSelectInputType": "mbr",
                                        "SearchByRegistryCodeString": regNo,
                                        "X-Requested-With": "XMLHttpRequest"
                                    }),
                                    headers: {
                                        Cookie: "SERVERID=Server1; " + this.cookie,
                                        'Content-type': 'application/x-www-form-urlencoded'
                                    }
                                });

                            case 6:
                                response = _context2.sent;
                                $ = _cheerio2.default.load(response.data);
                                row = $("table.ContentTable").find("tr")[1];
                                td = $(row).find("td");
                                data = {
                                    type: this.tidyString($(td[0]).text()),
                                    regNo: this.tidyString($(td[1]).text()),
                                    businessName: this.tidyString($(td[2]).text()),
                                    status: this.tidyString($(td[3]).text()),
                                    detailsLink: $(td[4]).find("a").attr("href")
                                };
                                return _context2.abrupt('return', data);

                            case 14:
                                _context2.prev = 14;
                                _context2.t0 = _context2['catch'](3);

                                console.log(_context2.t0);
                                return _context2.abrupt('return', null);

                            case 18:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this, [[3, 14]]);
            }));

            function searchByRegistrationNumber(_x) {
                return _ref2.apply(this, arguments);
            }

            return searchByRegistrationNumber;
        }()
    }]);

    return HttpClient;
}();

exports.default = new HttpClient();