require("babel-polyfill");
import client from './helpers/HttpClient';
import Record from './Entity/Record';

class AprApi {
    async getByRegistrationNumber(regNo) {
        if (!/^\d+$/.exec(regNo.toString())) {
            reject("Registration number must be numeric");
        }
        const data = await client.searchByRegistrationNumber(regNo);
        return new Record(data);
    }
}

export default new AprApi();
