const chai = require("chai");
const expect = chai.expect;
const chaiAsPromised = require("chai-as-promised");
chai.use(chaiAsPromised);
const apr = require("../dist/apr-api").default;

describe('Search by registration number', () => {
    describe('Validate search string', () => {
        it('rejects non-numeric strings', () => {
            return expect(apr.getByRegistrationNumber("foo")).to.eventually.be.rejected;
        });
        it('rejects mixed strings which begin with numbers', () => {
            return expect(apr.getByRegistrationNumber("123foo")).to.eventually.be.rejected;
        });
        it('rejects mixed strings which end with numbers', () => {
            return expect(apr.getByRegistrationNumber("foo123")).to.eventually.be.rejected;
        });
        it('rejects mixed strings which have numbers in the middle', () => {
            return expect(apr.getByRegistrationNumber("123foo123")).to.eventually.be.rejected;
        });
    });

    // Todo: Use Sinon stubs to check HttpClient calls
});